Subject: Re: How do queue-less virtual devices wake higher level senders?

From: Ben Greear <[email-masked]>
Date: Mon, 01 Oct 2007 17:24:26 -0700

David Miller wrote:
> From: Ben Greear <[email-masked]>
> Date: Mon, 01 Oct 2007 16:49:06 -0700
> 
>> For 'real' hardware, it seems that the netif_stop_queue and
>> netif_wake_queue methods handle stopping and waking the
>> higher level senders, but for virtual devices with no
>> queues, how does this work?
> 
> They don't queue, there is nothing to stop or wakeup.

Ok, so if I have a UDP socket bound to an interface that has
no queue, and yet I see the send portion of the queue being
full in netstat, what does this mean?

Maybe the device I think has no queue somehow does?

I added some debugging to print out dev->state in sysfs, and
the state of the virtual is always 0x6, which appears right
to me.  It's underlying device goes back and forth between 0x7 and 0x6,
which also seems right to me.

When the thing is in the hung state, phys and virtual interface have 0x6
state, and yet the udp tx queue remains full.  The physical NIC also
prints out some errors about being low on buffers right before the
hang, but it seems to recover since just doing a ping or starting
a second udp connection brings everything back to life.

Other than IFF_UP and dev->state, are there other things that
can make the tx logic stop sending to a device?

Thanks,
Ben

> -
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com